/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

void f(void)
{
  int m;
  int *u;
  int *p;
  __e_acsl_store_block((void *)(& p),(size_t)8);
  __e_acsl_store_block((void *)(& u),(size_t)8);
  __e_acsl_store_block((void *)(& m),(size_t)4);
  __e_acsl_full_init((void *)(& u));
  u = & m;
  __e_acsl_full_init((void *)(& p));
  p = u;
  __e_acsl_full_init((void *)(& m));
  m = 123;
  {
    int __gen_e_acsl_initialized;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"p",(void *)p);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,sizeof(int));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)p,sizeof(int));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\initialized(p)",0,
                                 __gen_e_acsl_initialized);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\initialized(p)";
    __gen_e_acsl_assert_data.file = "tests/memory/addrOf.i";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 10;
    __e_acsl_assert(__gen_e_acsl_initialized,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \initialized(p); */ ;
  __e_acsl_delete_block((void *)(& p));
  __e_acsl_delete_block((void *)(& u));
  __e_acsl_delete_block((void *)(& m));
  return;
}

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  int x = 0;
  f();
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&x",
                                 (void *)(& x));
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&x",
                                 (void *)(& x));
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "&x == &x";
    __gen_e_acsl_assert_data.file = "tests/memory/addrOf.i";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 16;
    __e_acsl_assert(& x == & x,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert &x == &x; */ ;
  __retres = 0;
  __e_acsl_memory_clean();
  return __retres;
}


